<?php

namespace App\Controllers\Admin;

use App\Controllers\BaseController;
use App\Models\Admin\ProductModel;

class Product extends BaseController
{

    private $productModel;

    public function __construct()
    {
        $this->productModel = new ProductModel();
    }

    public function index()
    {
        $category_id = $this->request->getGet('category_id');
        $status = $this->request->getGet('status');

        $this->productModel
            ->select('product.id, product.title, product.price, product.status, category.title AS category_title');

        if ($category_id) {
            $this->productModel->where('product.category_id', $category_id);
        }

        if ($status == '1' || $status == '0') {
            $this->productModel->where('product.status', $status);
        }

        $products = $this->productModel->join('category', 'category.id = product.category_id')
            ->orderBy('product.id ASC')
            ->paginate();

        return view('admin/product/index', [
            'title' => 'Список товаров',
            'products' => $products,
            'pager' => $this->productModel->pager,
            'category_id' => $category_id ?: 0,
            'status' => $status ?? '',
        ]);
    }
}
